/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
/* writerperfect
 * Version: MPL 2.0 / LGPLv2.1+
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * Major Contributor(s):
 * Copyright (C) 2002-2004 William Lachance (wrlach@gmail.com)
 * Copyright (C) 2004-2006 Fridrich Strba (fridrich.strba@bluewin.ch)
 *
 * For minor contributions see the git repository.
 *
 * Alternatively, the contents of this file may be used under the terms
 * of the GNU Lesser General Public License Version 2.1 or later
 * (LGPLv2.1+), in which case the provisions of the LGPLv2.1+ are
 * applicable instead of those above.
 *
 * For further information visit http://libwpd.sourceforge.net
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <string.h>

#include <libepubgen/libepubgen.h>

#include <libmwaw/libmwaw.hxx>

#include "EpubPackage.hxx"
#include "UsageHelper.hxx"

#define TOOLNAME "mwaw2epub"

class EpubOutputFileHelper
{
public:
	EpubOutputFileHelper(const char *const outFileName) :
		m_kind(MWAWDocument::MWAW_K_UNKNOWN), m_fileName(outFileName)
	{
	}

	bool convertDocument(librevenge::RVNGInputStream &input)
	{
		EpubPackage package(m_fileName);
		if (m_kind==MWAWDocument::MWAW_K_TEXT)
		{
			libepubgen::EPUBTextGenerator collector(&package);
			return MWAWDocument::MWAW_R_OK == MWAWDocument::parse(&input, &collector);
		}
		if (m_kind==MWAWDocument::MWAW_K_DRAW || m_kind == MWAWDocument::MWAW_K_PAINT)
		{
			libepubgen::EPUBDrawingGenerator collector(&package);
			return MWAWDocument::MWAW_R_OK == MWAWDocument::parse(&input, &collector);
		}
		if (m_kind==MWAWDocument::MWAW_K_PRESENTATION)
		{
			libepubgen::EPUBPresentationGenerator collector(&package);
			return MWAWDocument::MWAW_R_OK == MWAWDocument::parse(&input, &collector);
		}
		// must not happen
		return false;
	}

	bool isSupportedFormat(librevenge::RVNGInputStream &input)
	{
		MWAWDocument::Type type;
		MWAWDocument::Confidence confidence = MWAWDocument::isFileFormatSupported(&input, type, m_kind);
		if (confidence != MWAWDocument::MWAW_C_EXCELLENT)
		{
			fprintf(stderr, "ERROR: We have no confidence that you are giving us a valid Mac Classic document.\n");
			return false;
		}
		return m_kind == MWAWDocument::MWAW_K_TEXT || m_kind == MWAWDocument::MWAW_K_DRAW ||
		       m_kind == MWAWDocument::MWAW_K_PAINT || m_kind == MWAWDocument::MWAW_K_PRESENTATION;
	}

private:
	MWAWDocument::Kind m_kind;
	const char *m_fileName;
};

int printUsage(const char *name)
{
	UsageHelper usage(name, "converts Mac documents to ePub.", "[OPTIONS] INPUT OUTPUT");
	return usage.printUsage();
}

int printVersion(char const *name)
{
	printf("%s %s\n", name, VERSION);
	return 0;
}

int main(int argc, char *argv[])
{
	char *szInputFile = 0;
	char *szOutFile = 0;

	for (int i = 1; i < argc; i++)
	{
		if (strcmp(argv[i], "--version")==0)
			return UsageHelper::printVersion(TOOLNAME);
		else if (strcmp(argv[i], "--help")==0)
			return printUsage(TOOLNAME);
		else if (!szInputFile && strncmp(argv[i], "--", 2))
			szInputFile = argv[i];
		else if (szInputFile && !szOutFile && strncmp(argv[i], "--", 2))
			szOutFile = argv[i];
		else
			return printUsage(TOOLNAME);
	}

	if (!szInputFile || !szOutFile)
		return printUsage(TOOLNAME);

	librevenge::RVNGFileStream input(szInputFile);
	EpubOutputFileHelper helper(szOutFile);

	if (!helper.isSupportedFormat(input))
	{
		fprintf(stderr, "ERROR: the document is not in any supported format.\n");
		return 1;
	}

	if (!helper.convertDocument(input))
	{
		fprintf(stderr, "ERROR : Couldn't convert the document\n");
		return 1;
	}

	return 0;
}

/* vim:set shiftwidth=4 softtabstop=4 noexpandtab: */
